DEFINE TEMP-TABLE tt NO-UNDO
   FIELD i   AS INTEGER
   FIELD ii  AS INT64
   FIELD d   AS DATE
   FIELD dt  AS DATETIME
   FIELD dtz AS DATETIME-TZ
   FIELD x   AS CHARACTER.

DEFINE VARIABLE ii  AS INT64    EXTENT 3 INITIAL [0, 1, 2] NO-UNDO.
DEFINE VARIABLE d1  AS DATE     NO-UNDO.
DEFINE VARIABLE d2  AS DATE     NO-UNDO.
DEFINE VARIABLE d3  AS DATE     NO-UNDO.
DEFINE VARIABLE d4  AS DATE     NO-UNDO.
DEFINE VARIABLE d5  AS DATE     NO-UNDO.
DEFINE VARIABLE d6  AS DATE     NO-UNDO.
DEFINE VARIABLE d7  AS DATE     EXTENT 10 NO-UNDO.
DEFINE VARIABLE dt1 AS DATETIME NO-UNDO.
DEFINE VARIABLE dt2 AS DATETIME NO-UNDO.
DEFINE VARIABLE dt3 AS DATETIME NO-UNDO.
DEFINE VARIABLE dt4 AS DATETIME NO-UNDO.
DEFINE VARIABLE dt5 AS DATETIME NO-UNDO.
DEFINE VARIABLE dt6 AS DATETIME NO-UNDO.
DEFINE VARIABLE dt7 AS DATETIME EXTENT 10 INITIAL [?, 11/11/11, ?, 12/12] /*NOW, DATETIME(TODAY), ?, 0, "", ?]*/ NO-UNDO.

DEFINE VARIABLE dtz1 AS DATETIME-TZ NO-UNDO.
DEFINE VARIABLE dtz7 AS DATETIME-TZ EXTENT 10 NO-UNDO.
dtz7[3] = dtz1.

DISPLAY "SESSION:TIME-SOURCE = " SESSION:TIME-SOURCE SKIP.
SESSION:TIME-SOURCE = "p2j_test ".

DISPLAY "SESSION:YEAR-OFFSET = " SESSION:YEAR-OFFSET SKIP.
SESSION:YEAR-OFFSET = 1977.

DISPLAY "Unknowns:           " d1 dt1 SKIP WITH SIDE-LABELS NO-BOX.
DISPLAY "Extents:            " d7[1] dt7[1] SKIP.

d2  = DATE(11, 16, 1977).
dt2 = DATETIME(11, 16, 1977, 14, 35, 59).
DISPLAY "Assigned by fields: " d2 dt2 SKIP.

d3  = DATE("16-11-1977").              /* assume DMY format */
dt3 = DATETIME("16-11-1977 14:35:59"). /* assume DMY format */
DISPLAY "Parsed from string: " d3 dt3 SKIP.

d4  = DATE(dt3).
dt4 = DATETIME(d3).
DISPLAY "Cross assigned:     " d4 dt4 SKIP.

d5  = DATE(2500000).
dt5 = DATETIME(d5, ((14 * 60 + 35) * 60 + 59) * 1000 + 0).
DISPLAY "Using ints:         " d5  FORMAT "99/99/9999" 
                               dt5 FORMAT "99/99/9999" SKIP.

/* test int64 array */
ii[1] = 2500000.
dt5 = DATE(ii[1]).

d7[1]  = d7[2].  /* EXTENTs read/write access */
dt7[1] = dt7[2]. /* EXTENTs read/write access */

d6  = 11/11/11. /* = operator, assign to date literal */
dt6 = 11/11/11. /* = operator, assign to date literal */
d6  = ?.        /* = operator, assign to unknown */
dt6 = ?.        /* = operator, assign to unknown */
d6  = dt5.      /* = operator, assign date to datetime */
dt6 = d5.       /* = operator, assign datetime to date */
d6  = TODAY.    /* = operator, assign date to date, TODAY function  */
dt6 = NOW.      /* = operator, assign datetime to datetime, NOW function */

DISPLAY "STRING function:    " STRING(d6)    STRING(dt6)    SKIP.

DISPLAY "ISO-DATE function:  " ISO-DATE(d6)  FORMAT "x(10)"
                               ISO-DATE(dt6) FORMAT "x(23)" SKIP.
DISPLAY "DAY function:       " DAY(d6)       DAY(dt6)       SKIP.
DISPLAY "MONTH function:     " MONTH(d6)     MONTH(dt6)     SKIP.
DISPLAY "YEAR function:      " YEAR(d6)      YEAR(dt6)      SKIP.
DISPLAY "WEEKDAY function:   " WEEKDAY(d6)   WEEKDAY(dt6)   SKIP.
DISPLAY "MTIME function:     " MTIME(dt6)    MTIME          SKIP.

DISPLAY "INTERVAL function:  " INTERVAL(d6, dt6, "seconds") SKIP.
DISPLAY "ADD-INTERVAL funct: " 
        ADD-INTERVAL(d6,  31, "days")
        ADD-INTERVAL(dt6, 48, "hours")
        SKIP.

DISPLAY "+ operator:         " d6 +  10     dt6 +  1000 * 60 * 60 * 24 * 3  SKIP.
DISPLAY "- operator 1:       " d6 -  10     dt6 -  1000 * 60 * 60 * 24 * 3  SKIP.
DISPLAY "- operator 2:       " d6 -  TODAY  dt6 -  NOW        SKIP.
DISPLAY "> & >= operator:    " d6 >  TODAY  dt6 >  NOW 
                               d6 >= TODAY  dt6 >= NOW        SKIP.
DISPLAY "< & <= operator:    " d6 <  TODAY  dt6 <  NOW
                               d6 <= TODAY  dt6 <= NOW        SKIP.
DISPLAY "= & <> operator:    " d6  = TODAY  dt6  = NOW
                               d6 <> TODAY  dt6 <> NOW        SKIP.

DISPLAY "DECIMAL INT INT64:  " DECIMAL(d6) FORMAT "->,>>>,>>9.99"
                               INTEGER(d6) INT64(d6).

/*
 * Sample expected output:
 *
SESSION:TIME-SOURCE =  LOCAL
SESSION:YEAR-OFFSET =  1,950
Unknowns:            d1:          dt1:
Extents:             d7[1]:          dt7[1]:
Assigned by fields:  d2: 16/11/77 dt2: 16/11/1977 14:35:59.000
Parsed from string:  d3: 16/11/77 dt3: 16/11/1977 14:35:59.000
Cross assigned:      d4: 16/11/77 dt4: 16/11/1977 00:00:00.000
Using ints:          d5: 30/08/2132 dt5: 30/08/2132
STRING function:     18/01/13 18/01/20
ISO-DATE function:   2013-01-18 2013-01-18T16:03:51.804
DAY function:        18         18
MONTH function:      1          1
YEAR function:       2,013      2,013
WEEKDAY function:    6          6
MTIME function:      57,831,804 57,831,811
INTERVAL function:   0
ADD-INTERVAL funct:  18/02/13 20/01/2013 16:03:51.804
+ operator:          28/01/13 21/01/2013 16:03:51.804
- operator 1:        08/01/13 15/01/2013 16:03:51.804
- operator 2:        0          -15
> & >= operator:     no  no  yes no
< & <= operator:     no  yes yes yes
 *
 */
